# class Zlib::ZStream

`Zlib::ZStream` is the abstract class for the stream which handles the compressed data. The operations are defined in the subclasses: `Zlib::Deflate` for compression, and `Zlib::Inflate` for decompression.

An instance of `Zlib::ZStream` has one stream (struct zstream in the source) and two variable-length buffers which associated to the input (next_in) of the stream and the output (next_out) of the stream. In this document, “input buffer” means the buffer for input, and “output buffer” means the buffer for output.

`Data` input into an instance of `Zlib::ZStream` are temporally stored into the end of input buffer, and then data in input buffer are processed from the beginning of the buffer until no more output from the stream is produced (i.e. until `avail_out` > 0 after processing). During processing, output buffer is allocated and expanded automatically to hold all output data.

Some particular instance methods consume the data in output buffer and return them as a `String`.

Here is an ascii art for describing above:

    +================ an instance of Zlib::ZStream ================+
    ||                                                            ||
    ||     +--------+          +-------+          +--------+      ||
    ||  +--| output |<---------|zstream|<---------| input  |<--+  ||
    ||  |  | buffer |  next_out+-------+next_in   | buffer |   |  ||
    ||  |  +--------+                             +--------+   |  ||
    ||  |                                                      |  ||
    +===|======================================================|===+
        |                                                      |
        v                                                      |
    "output data"                                         "input data"

If an error occurs during processing input buffer, an exception which is a subclass of `Zlib::Error` is raised. At that time, both input and output buffer keep their conditions at the time when the error occurs.

## `Method` Catalogue¶ ↑

Many of the methods in this class are fairly low-level and unlikely to be of interest to users. In fact, users are unlikely to use this class directly; rather they will be interested in `Zlib::Inflate` and `Zlib::Deflate`.

The higher level methods are listed below.

- `total_in`

- `total_out`

- `data_type`

- `adler`

- `reset`

- `finish`

- `finished?`

- `close`

- `closed?`

### Public Instance Methods

adler ()
Source

    static VALUE
    rb_zstream_adler(VALUE obj)
    {
        return rb_uint2inum(get_zstream(obj)->stream.adler);
    }

Returns the adler-32 checksum.

avail_in ()
Source

    static VALUE
    rb_zstream_avail_in(VALUE obj)
    {
        struct zstream *z;
        TypedData_Get_Struct(obj, struct zstream, &zstream_data_type, z);
        return INT2FIX(NIL_P(z->input) ? 0 : (int)(RSTRING_LEN(z->input)));
    }

Returns bytes of data in the input buffer. Normally, returns 0.

avail_out ()
Source

    static VALUE
    rb_zstream_avail_out(VALUE obj)
    {
        struct zstream *z;
        TypedData_Get_Struct(obj, struct zstream, &zstream_data_type, z);
        return rb_uint2inum(z->stream.avail_out);
    }

Returns number of bytes of free spaces in output buffer. Because the free space is allocated automatically, this method returns 0 normally.

avail_out= (p1)
Source

    static VALUE
    rb_zstream_set_avail_out(VALUE obj, VALUE size)
    {
        struct zstream *z = get_zstream(obj);

        zstream_expand_buffer_into(z, FIX2INT(size));
        return size;
    }

Allocates `size` bytes of free space in the output buffer. If there are more than `size` bytes already in the buffer, the buffer is truncated. Because free space is allocated automatically, you usually don’t need to use this method.

close ()
Source

    static VALUE
    rb_zstream_end(VALUE obj)
    {
        zstream_end(get_zstream(obj));
        return Qnil;
    }

Closes the stream. All operations on the closed stream will raise an exception.

Also aliased as: end
closed? ()
Source

    static VALUE
    rb_zstream_closed_p(VALUE obj)
    {
        struct zstream *z;
        TypedData_Get_Struct(obj, struct zstream, &zstream_data_type, z);
        return ZSTREAM_IS_READY(z) ? Qfalse : Qtrue;
    }

Returns true if the stream is closed.

Also aliased as: ended?
data_type ()
Source

    static VALUE
    rb_zstream_data_type(VALUE obj)
    {
        return INT2FIX(get_zstream(obj)->stream.data_type);
    }

Guesses the type of the data which have been inputted into the stream. The returned value is either `BINARY`, `ASCII`, or `UNKNOWN`.

end ()

Closes the stream. All operations on the closed stream will raise an exception.

Alias for: close
ended? ()

Returns true if the stream is closed.

Alias for: closed?
finish → String
finish { |chunk| ... } → nil
Source

    static VALUE
    rb_zstream_finish(VALUE obj)
    {
        struct zstream *z = get_zstream(obj);

        zstream_run(z, (Bytef*)"", 0, Z_FINISH);

        return zstream_detach_buffer(z);
    }

Finishes the stream and flushes output buffer. If a block is given each chunk is yielded to the block until the input buffer has been flushed to the output buffer.

finished? ()
Source

    static VALUE
    rb_zstream_finished_p(VALUE obj)
    {
        return ZSTREAM_IS_FINISHED(get_zstream(obj)) ? Qtrue : Qfalse;
    }

Returns true if the stream is finished.

Also aliased as: stream_end?
flush_next_in → input
Source

    static VALUE
    rb_zstream_flush_next_in(VALUE obj)
    {
        struct zstream *z;
        VALUE dst;

        TypedData_Get_Struct(obj, struct zstream, &zstream_data_type, z);
        dst = zstream_detach_input(z);
        return dst;
    }

flush_next_out → String
flush_next_out { |chunk| ... } → nil
Source

    static VALUE
    rb_zstream_flush_next_out(VALUE obj)
    {
        struct zstream *z;

        TypedData_Get_Struct(obj, struct zstream, &zstream_data_type, z);

        return zstream_detach_buffer(z);
    }

Flushes output buffer and returns all data in that buffer. If a block is given each chunk is yielded to the block until the current output buffer has been flushed.

reset ()
Source

    static VALUE
    rb_zstream_reset(VALUE obj)
    {
        zstream_reset(get_zstream(obj));
        return Qnil;
    }

Resets and initializes the stream. All data in both input and output buffer are discarded.

stream_end? ()

Returns true if the stream is finished.

Alias for: finished?
total_in ()
Source

    static VALUE
    rb_zstream_total_in(VALUE obj)
    {
        return rb_uint2inum(get_zstream(obj)->stream.total_in);
    }

Returns the total bytes of the input data to the stream. FIXME

total_out ()
Source

    static VALUE
    rb_zstream_total_out(VALUE obj)
    {
        return rb_uint2inum(get_zstream(obj)->stream.total_out);
    }

Returns the total bytes of the output data from the stream. FIXME